{%- from "shuup_definite_theme/macros/basket.jinja" import render_partial_basket_supplier_info -%}
{%- from "shuup/front/macros/general.jinja" import render_field with context -%}
{%- set root_categories = shuup.general.get_root_categories() -%}

{% macro render_navigation(show_quick_login=True) %}
    <nav class="site-nav" role="navigation">
        <div class="container">
            <div class="flex-row row">
                <div class="logo-wrap">
                    <button class="nav-toggler" id="offcanvas-nav-toggler" type="button" aria-haspopup="true" aria-controls="offcanvas-nav" aria-expanded="false">
                        <span class="hamburger"></span>
                        <span class="sr-only">{% trans %}Mobile menu{% endtrans %}</span>
                    </button>
                    {{ render_logo() }}
                </div>
                <div class="secondary-nav clearfix{% if xtheme.search_on_top() %} search-on-top{% endif %}">
                    {%- set languages = shuup.general.get_shop_language_choices() -%}
                    {% if xtheme.search_on_top() %}
                        {{ render_nav_search() }}
                        <div class="secondary-nav-dropdowns">
                            {%- if languages|length > 1 -%}
                                <div class="hidden-sm hidden-xs">
                                    {{- render_language_changer() -}}
                                </div>
                            {% endif %}
                            {%- cache 600 request.basket.get_cache_key() request.session.session_key -%}
                                {{ render_nav_basket() }}
                            {%- endcache -%}
                            {{ render_user_nav_list(show_quick_login) }}
                        </div>
                    {% else %}
                        <div class="secondary-nav-dropdowns">
                            {%- if languages|length > 1 -%}
                                <div class="hidden-sm hidden-xs">
                                    {{- render_language_changer() -}}
                                </div>
                            {% endif %}
                            {%- cache 600 request.basket.get_cache_key() request.session.session_key -%}
                                {{ render_nav_basket() }}
                            {%- endcache -%}
                            {{ render_user_nav_list(show_quick_login) }}
                        </div>
                        {{ render_nav_search() }}
                    {% endif %}
                </div>
            </div>
        </div>
    </nav>
    {{ render_menu() }}
    {{ render_offcanvas_nav() }}
{% endmacro %}

{% macro render_checkout_navigation() %}
    <nav class="site-nav checkout-nav" role="navigation">
        <div class="container">
            <div class="flex-row row">
                <div class="logo-wrap">
                    {{ render_logo() }}
                </div>
            </div>
        </div>
    </nav>
    <div class="container">
        <a href="{{ url('shuup:basket') }}" class="btn btn-default">
            <i class="fa fa-arrow-left fa-fw"></i> {{ _("Back to shop") }}
        </a>
    </div>
{% endmacro %}

{% macro render_nav_basket() %}
    {% if not xtheme.get("catalog_mode") %}
        <div class="nav-basket-element{% if xtheme.bigger_cart_text() %} bigger-cart{% endif %}" id="navigation-basket-partial" aria-label="{% trans %}Shopping cart{% endtrans %}">
            {{ render_basket_partial(request.basket) }}
        </div>
    {% endif %}
{% endmacro %}

{% macro render_nav_search() %}
    <form method="get" action="{{ url('shuup:product_search') }}" class="search-form" role="search">
        <div class="search-container">
            <input type="search" id="nav-search" name="q" class="form-control" placeholder="{% trans %}Search{% endtrans %}" required>
            <button type="submit" class="search-submit-btn">
                <span class="sr-only">{% trans %}Search{% endtrans %}</span>
                <i class="fa fa-search"></i>
            </button>
        </div>
    </form>
{% endmacro %}

{% macro render_language_changer() %}
    {%- set languages = shuup.general.get_shop_language_choices() -%}

    {%- if languages|length > 1 -%}
        {% set lang = {"name": LANGUAGE_CODE} %}
        {% for (code, name, local_name) in languages %}
            {% if code == LANGUAGE_CODE %}
                {% if lang.update({"name": local_name}) %}{% endif %}
            {% endif %}
        {% endfor %}
        <ul class="language-nav dropdown" id="language-changer" aria-label="{% trans %}Language select{% endtrans %}">
            <li>
                <a aria-expanded="false" href="#" class="dropdown-toggle" data-toggle="dropdown">
                    <i class="menu-icon fa fa-globe"></i>
                    {{ lang.name|capitalize }}
                    <i class="dropdown-icon fa fa-angle-down"></i>
                </a>
                <ul class="dropdown-menu languages" role="menu">
                    {% for (code, name, local_name) in languages %}
                        <li>
                            <a href="#" class="language" data-value="{{ code }}">
                                <span lang="{{ code }}">{{ local_name|capitalize }}</span> ({{ name }})
                            </a>
                        </li>
                    {% endfor %}
                </ul>
            </li>
        </ul>
    {%- endif -%}
{% endmacro %}

{% macro render_basket_partial_line(line) %}
<tr>
    <td class="v-middle">
        {% set line_url = shuup.urls.get_url(line.product) %}
        {{ line.quantity|number }} &times;
        {% if line_url %}
            <a href="{{ line_url }}">{{ line.text|truncate(40, False) }}</a>
        {% else %}
            {{ line.text|truncate(40, False) }}
        {% endif %}
    </td>
    {% if show_prices() and not xtheme.get("hide_prices") %}
        <td class="v-middle text-right">{{ line|price(allow_cache=False) }}</td>
    {% endif %}
    <td class="v-middle">
        {% if line.can_delete %}
        <form method="post" action="{{ url('shuup:basket') }}" name="basket_partial_remove">
            {% csrf_token %}
            <input name="command" type="hidden" value="update">
            <input name="return" type="hidden" value="{{ request.path }}">
            <button type="submit"
                    class="btn btn-remove"
                    name="delete_{{ line.line_id }}"
                    title="{% trans %}Remove product from basket{% endtrans %}">
                <i class="fa fa-times"></i>
            </button>
        </form>
        {% endif %}
    </td>
</tr>
{% endmacro %}

{% macro render_basket_partial(basket, id=None) %}
    {% if show_prices() and not xtheme.get("hide_prices") %}
        {% set lines = request.basket.get_lines() %}
        <div class="dropdown cart"{% if id %} id="{{ id }}"{% endif %}>
            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                <i class="menu-icon fa fa-shopping-bag"></i>
                <span class="hidden-xs">{% trans %}Cart{% endtrans %}</span>
                <span>({{ basket.product_count }})</span>
                <span class="hidden-xs">{{ basket|total_price }}</span>
                <i class="dropdown-icon fa fa-angle-down hidden-xs"></i>
            </a>
            <div class="dropdown-menu cart">
                {% if lines %}
                    <table class="table">
                        <colgroup>
                            <col style="min-width: 180px;">
                            <col style="min-width: 90px;">
                            <col style="min-width: 50px;">
                        </colgroup>
                        <thead>
                            <tr>
                                <th>{% trans %}Items{% endtrans %}</th>
                                <th class="text-right">{% trans %}Price{% endtrans %}</th>
                                <th></th>
                            </tr>
                        </thead>
                        <tfoot>
                            <tr>
                                <th>{% trans %}Total{% endtrans %}</th>
                                <th class="text-right">{{ basket|total_price }}</th>
                                <th></th>
                            </tr>
                        </tfoot>
                        <tbody>
                            {% if xtheme.get("group_items_by_supplier") %}
                                {% set groupped_lines = xtheme.group_lines_by_supplier(lines) %}
                                {% for supplier, lines in groupped_lines.items() %}
                                    {% if supplier %}
                                        <tr class="supplier-info-row">
                                            <td colspan="2">
                                                {{ render_partial_basket_supplier_info(supplier) }}
                                            </td>
                                        </tr>
                                    {% endif %}
                                    {% for line in lines %}
                                        {{ render_basket_partial_line(line) }}
                                    {% endfor %}
                                {% endfor %}
                            {% else %}
                                {% for line in lines %}
                                    {{ render_basket_partial_line(line) }}
                                {% endfor %}
                            {% endif %}
                        </tbody>
                    </table>
                    <a href="{{ url('shuup:basket') }}" class="btn btn-block btn-primary btn-view-cart">
                        {% trans %}View cart{% endtrans %} <i class="fa fa-angle-double-right"></i>
                    </a>
                {% else %}
                    <span class="empty-cart">
                        <i class="fa fa-exclamation-circle text-warning"></i>
                        {% trans %}Your shopping cart is empty.{% endtrans %}
                    </span>
                {% endif %}
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro _render_info_for_authenticated_users() %}
    <li class="dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown">
            <i class="menu-icon fa fa-user"></i>
            <span class="hidden-xs">
                {{ request.customer.name }}
            </span>
            <i class="dropdown-icon fa fa-angle-down"></i>
        </a>
        <ul class="dropdown-menu" role="menu">
            {{ caller() }}
        </ul>
    </li>
{% endmacro %}

{% macro _render_info_for_anonymous_users() %}
    <li class="dropdown" id="login-dropdown">
        <a href="#" class="dropdown-toggle" data-toggle="dropdown">
            <i class="menu-icon fa fa-user"></i> <span class="hidden-xs">{% trans %}Log in{% endtrans %}</span>
            <i class="dropdown-icon fa fa-angle-down"></i>
        </a>
        <ul class="dropdown-menu login" role="dropdown-menu">
            {{ caller() }}
        </ul>
    </li>
{% endmacro %}

{% macro render_user_nav_list(show_quick_login) %}
    <ul class="user-nav" aria-label="{% trans %}User menu{% endtrans %}">
        {% if user.is_authenticated %}
            {% set person_name = (request.person.firstname or request.user.username) %}
            <li class="dropdown">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                    <i class="menu-icon fa fa-user"></i>
                    <span>
                        {{ person_name|capitalize }}
                    </span>
                    <i class="dropdown-icon fa fa-angle-down hidden-xs"></i>
                </a>
                <ul class="dropdown-menu" role="menu">
                    {% if shuup.general.is_shop_admin() %}
                        <li>
                            <a href="{{ url('shuup_admin:dashboard') }}">
                                {% trans %}Admin Panel{% endtrans %}
                            </a>
                        </li>
                    {% endif %}
                    {% if request.person and shuup.urls.has_url("shuup:dashboard") %}
                        <li>
                            <a href="{{ url('shuup:dashboard') }}">
                                {% trans %}My Account{% endtrans %}
                            </a>
                        </li>
                    {% endif %}
                    {% if request.person and shuup.urls.has_url("shuup:personal_wishlists") %}
                        <li>
                            <a href="{{ url('shuup:personal_wishlists') }}">
                                {% trans %}Wishlist{% endtrans %}
                            </a>
                        </li>
                    {% endif %}
                    <li role="separator" class="divider"></li>
                    <li>
                        <a href="{{ url('shuup:logout') }}">
                            {% trans %}Logout{% endtrans %}
                        </a>
                    </li>
                </ul>
            </li>
        {% elif show_quick_login %} {# Checking if the login dropdown should be shown #}
            {% call _render_info_for_anonymous_users() %}
                <li>
                    <form role="form" method="post" action="{{ url('shuup:login') }}">
                        {% csrf_token %}
                        {% if request.resolver_match.url_name == "logout" %}{% set next="/" %}{% endif %}
                        <input type="hidden" name="next" value="{{ next or request.path }}">
                        {% set form = shuup.general.get_login_form(request) %}
                        {% for f in form.hidden_fields() %}{{ f }}{% endfor %}
                        {% for f in form.visible_fields() %}{{ render_field(f, show_help_text=False) }}{% endfor %}

                        <button type="submit" class="btn btn-primary btn-block">
                            {% trans %}Log in{% endtrans %}
                        </button>
                    </form>
                </li>

                <li class="divider"></li>

                {% if shuup.urls.has_url("shuup:recover_password") %}
                    <li>
                        <a href="{{ url('shuup:recover_password') }}">
                            <i class="fa fa-question fa-fw"></i> {% trans %}Forgot your password?{% endtrans %}
                        </a>
                    </li>
                {% endif %}

                {% if shuup.urls.has_url("shuup:registration_register") %}
                    <li>
                        <a href="{{ url('shuup:registration_register') }}{% if next %}?next={{next}}{% endif %}">
                            <i class="fa fa-edit fa-fw"></i> {% trans %}New user? Register here!{% endtrans %}
                        </a>
                    </li>
                {% endif %}
            {% endcall %}
        {% endif %}
    </ul>
{% endmacro %}

{% macro render_logo() %}
    {% if request.shop.logo %}
        {% set best_height = 120 %}

        {% set original_height = request.shop.logo.height %}
        {% set original_width = request.shop.logo.width %}

        {% set logo_width = original_width %}
        {% set logo_height = original_height %}

        {% if original_height > best_height %}
            {% set logo_height = best_height %}
            {% set logo_width = ((original_width / original_height) * logo_height)|int %}
        {% endif %}

        {% if original_width > original_height %}
            {% set logo_direction = "logo-horizontal" %}
        {% elif original_height > original_width %}
            {% set logo_direction = "logo-vertical" %}
        {% else %}
            {% set logo_direction = "logo-square" %}
        {% endif %}

        {% set cropped_logo = request.shop.logo|thumbnail(size=(logo_width, logo_height), quality=100) %}
    {% endif %}
    <div class="logo{% if not cropped_logo %} no-image{% else %} has-image {{ logo_direction }}{% endif %}">
        <a href="/" data-toggle="tooltip" data-placement="bottom" title="{{ request.shop }} {% trans %}Home{% endtrans %}">
            {% if cropped_logo %}
                {{ lazy_img_image(cropped_logo, "", request.shop) }}
            {% else %}
                <div class="h4">{{ request.shop.public_name }}</div>
            {% endif %}
        </a>
    </div>
{% endmacro %}

{% macro render_menu() %}
<nav role="navigation" aria-label="{% trans %}Main menu{% endtrans %}">
    {% if not xtheme.full_width_menu_bar() %}
    <div class="container">
    {% endif %}
        <div class="main-menu" id="main-menu">
            {% if xtheme.full_width_menu_bar() %}
            <div class="container">
            {% endif %}
            <ul class="menu-items">
                {% if xtheme.show_homepage_link_in_nav() %}
                    <li class="{% if request.path == '/' %}current{% endif %}">
                        <a href="/">
                            {% if xtheme.homepage_icon_in_nav() %}
                                <span class="sr-only">{% trans %}Homepage{% endtrans %}</span>
                                <i class="fa fa-home" aria-hidden="true"></i>
                            {% else %}
                                {% trans %}Homepage{% endtrans %}
                            {% endif %}
                        </a>
                    </li>
                {% endif %}

                {% set items_per_row = 4 %}
                {% for c in root_categories if c.visible_in_menu %}
                    {% set children = c.get_children() %}

                    {% if c.level == 0 %}
                        {% set divider = (children|length / items_per_row)|round(0, "ceil")|int %}
                        {% if divider < items_per_row %}
                            {% set divider = items_per_row %}
                        {% endif %}
                    {% endif %}
                    <li class="level-{{ c.level }} category-link{% if children %} is-parent{% endif %}{% if category and c == category %} current{% endif %}">
                        <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}">{{ c.name }}</a>

                        {% if children and c.level == 0 %}
                            <div class="mega-menu-container {% if c.id == 0 %}open{% endif %}">
                                <ul>
                                    {% for child in children recursive %}
                                        {% set child_children = child.get_children() %}
                                        <li class="level-{{ child.level }} category-link{% if child_children %} is-parent{% endif %}{% if category and c == category %} current{% endif %}">
                                            <a href="{{ url('shuup:category', pk=child.pk, slug=child.slug) }}">
                                                {{ child.name }}
                                            </a>
                                            {% if child_children and xtheme.show_child_elements_in_megamenu() %}
                                                <ul>
                                                    {{ loop(child_children) }}
                                                </ul>
                                            {% endif %}
                                            {% if loop.index|divisibleby(divider) %}
                                                {% if not loop.last %}
                                                </ul>
                                                {% endif %}
                                                <ul>
                                            {% endif %}
                                        </li>
                                    {% endfor %}
                                </ul>
                            </div>
                        {% endif %}
                    </li>
                {% endfor %}

                {% if xtheme.get_vendor_menu_link() %}
                    <li class="vendors-link {% if request.path == '/v/' %}current{% endif %}">
                        <a href="/v/">
                            {{ xtheme.get_vendor_menu_link() }}
                        </a>
                    </li>
                {% endif %}

                {{ render_cms_nav_list() }}
            </ul>
            {% if xtheme.full_width_menu_bar() %}
            </div>
            {% endif %}
        </div>
    {% if not xtheme.full_width_menu_bar() %}
    </div>
    {% endif %}
</nav>
{% endmacro %}

{% macro render_offcanvas_nav() %}
    <div class="offcanvas-nav" id="offcanvas-nav" role="navigation" aria-label="{% trans %}Main menu{% endtrans %}">
        {%- set languages = shuup.general.get_shop_language_choices() -%}
        {%- if languages|length > 1 -%}
            <div class="offcanvas-lang">
                {{- render_language_changer() -}}
            </div>
        {%- endif -%}

        <div class="offcanvas-search">
            <div class="offcanvas-search-wrap">
                <form method="get" action="{{ url('shuup:product_search') }}" role="search">
                    <input type="text" name="q" class="form-control offcanvas-search-input" id="offcanvas-search-form" placeholder="{% trans %}Search...{% endtrans %}">
                    <button class="btn offcanvas-search-submit" type="submit">
                        <i class="fa fa-search"></i>
                        <span class="sr-only">{% trans %}Search{% endtrans %}</span>
                    </button>
                </form>
            </div>
        </div>

        <ul>
            {% if xtheme.show_homepage_link_in_nav() %}
                <li class="level-0{% if request.path == '/' %} current{% endif %}">
                    <a href="/">
                        {% trans %}Homepage{% endtrans %}
                    </a>
                </li>
            {% endif %}
            {% for c in root_categories if c.visible_in_menu recursive %}
                {% set children = c.get_children() %}
                <li class="level-{{ c.level }} category-link{% if children %} is-parent{% endif %}{% if category and c == category %} current is-open{% endif %}">
                    <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}">
                        {{ c.name }}
                    </a>
                    {% if children %}
                        <button class="toggle-icon" type="button" aria-expanded="false" aria-controls="child-of-{{ c.pk }}">
                            <span class="sr-only">
                                {%- trans category_name = c.name -%}
                                    Toggle children for {{ category_name }}
                                {%- endtrans -%}
                            </span>
                        </button>
                        <ul id="child-of-{{ c.pk }}">
                            {{ loop(children) }}
                        </ul>
                    {% endif %}
                </li>
            {% endfor %}
            {{ render_cms_nav_list() }}
        </ul>
    </div>
{% endmacro %}

{% macro render_cms_nav_list() %}
    {%- if shuup.simple_cms -%}
        {%- for page in xtheme.get_cms_navigation_links(request) -%}
            <li class="level-{{ loop.depth0 }} cms-link{% if request.path == '%s/' % page.url %} current{% endif %}">
                <a href="{{ page.url }}">
                    {{ page.text }}
                </a>
            </li>
        {%- endfor -%}
    {%- endif -%}
{% endmacro %}
